    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2006, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------------
    028     * XIntervalSeries.java
    029     * --------------------
    030     * (C) Copyright 2006, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: XIntervalSeries.java,v 1.1.2.3 2006/10/23 09:19:50 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 20-Oct-2006 : Version 1 (DG);
    040     *
    041     */
    042
    043    package org.jfree.data.xy;
    044
    045    import org.jfree.data.ComparableObjectItem;
    046    import org.jfree.data.ComparableObjectSeries;
    047
    048    /**
    049     * A list of (x, x-low, x-high, y) data items.
    050     *
    051     * @since 1.0.3
    052     *
    053     * @see XIntervalSeriesCollection
    054     */
    055    public class XIntervalSeries extends ComparableObjectSeries {
    056
    057        /**
    058         * Creates a new empty series.  By default, items added to the series will
    059         * be sorted into ascending order by x-value, and duplicate x-values will
    060         * be allowed (these defaults can be modified with another constructor.
    061         *
    062         * @param key  the series key (<code>null</code> not permitted).
    063         */
    064        public XIntervalSeries(Comparable key) {
    065            this(key, true, true);
    066        }
    067
    068        /**
    069         * Constructs a new xy-series that contains no data.  You can specify
    070         * whether or not duplicate x-values are allowed for the series.
    071         *
    072         * @param key  the series key (<code>null</code> not permitted).
    073         * @param autoSort  a flag that controls whether or not the items in the
    074         *                  series are sorted.
    075         * @param allowDuplicateXValues  a flag that controls whether duplicate
    076         *                               x-values are allowed.
    077         */
    078        public XIntervalSeries(Comparable key, boolean autoSort,
    079                boolean allowDuplicateXValues) {
    080            super(key, autoSort, allowDuplicateXValues);
    081        }
    082
    083        /**
    084         * Adds a data item to the series.
    085         *
    086         * @param x  the x-value.
    087         * @param y  the y-value.
    088         * @param xLow  the lower bound of the y-interval.
    089         * @param xHigh  the upper bound of the y-interval.
    090         */
    091        public void add(double x, double xLow, double xHigh, double y) {
    092            super.add(new XIntervalDataItem(x, xLow, xHigh, y), true);
    093        }
    094
    095        /**
    096         * Returns the x-value for the specified item.
    097         *
    098         * @param index  the item index.
    099         *
    100         * @return The x-value (never <code>null</code>).
    101         */
    102        public Number getX(int index) {
    103            XIntervalDataItem item = (XIntervalDataItem) getDataItem(index);
    104            return item.getX();
    105        }
    106
    107        /**
    108         * Returns the y-value for the specified item.
    109         *
    110         * @param index  the item index.
    111         *
    112         * @return The y-value.
    113         */
    114        public double getYValue(int index) {
    115            XIntervalDataItem item = (XIntervalDataItem) getDataItem(index);
    116            return item.getYValue();
    117        }
    118
    119        /**
    120         * Returns the data item at the specified index.
    121         *
    122         * @param index  the item index.
    123         *
    124         * @return The data item.
    125         */
    126        public ComparableObjectItem getDataItem(int index) {
    127            return super.getDataItem(index);
    128        }
    129
    130    }